param (
	[Parameter(Mandatory=$true, Position=0)]
	[string] $repositoryUrl,
	[Parameter(Mandatory=$true, Position=1)]
	[string] $branch,
	[Parameter(Mandatory=$true, Position=2)]
	[string] $repositoryFolder
)

$extractPath = "C:\Programs\Consul\"
$fileName = "Consul.exe"
$fullPath = ($extractPath + $fileName)

$gitlab_token = & $fullPath kv get "coscine/global/gitlabtoken"

Push-Location $PSScriptRoot

# Twice remove, because of: https://stackoverflow.com/questions/7909167/how-to-quietly-remove-a-directory-with-content-in-powershell#comment10316056_7909195
If(Test-Path $repositoryFolder) { Remove-Item -LiteralPath $repositoryFolder -Force -Recurse }
If(Test-Path $repositoryFolder) { Remove-Item -LiteralPath $repositoryFolder -Force -Recurse }

git clone https://gitlab-ci-token:$gitlab_token@$repositoryUrl

cd $repositoryFolder

if ($branch -And $branch -ne 'master' ) {
	git checkout $branch
	git pull
}

cd ..

$path = 'C:/voc'

# Twice remove, because of: https://stackoverflow.com/questions/7909167/how-to-quietly-remove-a-directory-with-content-in-powershell#comment10316056_7909195
If(Test-Path $path) { Remove-Item -LiteralPath $path -Force -Recurse }
If(Test-Path $path) { Remove-Item -LiteralPath $path -Force -Recurse }

New-Item -ItemType Directory -Force -Path $path

Copy-Item "./$repositoryFolder/*" $path -Recurse;

# Twice remove, because of: https://stackoverflow.com/questions/7909167/how-to-quietly-remove-a-directory-with-content-in-powershell#comment10316056_7909195
If(Test-Path $repositoryFolder) { Remove-Item -LiteralPath $repositoryFolder -Force -Recurse }
If(Test-Path $repositoryFolder) { Remove-Item -LiteralPath $repositoryFolder -Force -Recurse }

Pop-Location
